#!/usr/bin/perl
#
#
# stupid name? any ideas?

use strict;
use warnings;
use Data::Dumper;
use POSIX qw/strftime/;

use Net::SNMP qw(:snmp);

# TODO: 
#  - useful syntax
#  - what about snmp versions > 1
my $version     = shift;
my $hostname 	= shift || 'localhost';
my $community 	= shift || 'public';
my $port 	= shift || 161;

my ($session, $error) = Net::SNMP->session
	( -version	=> 'snmpv1',
	, -hostname	=> $hostname
	, -community	=> $community
	, -port		=> $port
	);

die("ERROR: " . $error)
	unless defined $session;

my $ifTable = '1.3.6.1.2.1.2.2';

# TODO: should i use constants?
my %ifEntry_fields	=
	( 2	=> 'ifDescr' 

	, 10	=> 'ifInOctets'
	, 11	=> 'ifInUcastPkts'
	, 12	=> 'ifInNUcastPkts'
	, 13	=> 'ifInDiscards'
	, 14	=> 'ifInErrors'

	, 16	=> 'ifOutOctets'
	, 17	=> 'ifOutUcastPkts'
	, 18	=> 'ifOutNUcastPkts'
	, 19	=> 'ifOutDiscards'
	, 20	=> 'ifOutErrors'
	);

while (1) {
	# TODO: perhaps we can fetch only needed entries and fields/columns...
	my $result = $session->get_table(-baseoid => $ifTable )
	   or die("ERROR: " .  $session->error);

	print "UPDATE", " ", strftime("%Y-%m-%d %H:%M:%S", localtime), "\n";

	# TODO: - printf?
	print "NODE", " ",  $hostname, " ", "SNMP", "\n";
	print "GROUP", " ", "intf", "\n";
	my %interfaces; 

	while ( my ($oid, $value) = each %$result ) {
		#                   fi val
		# 1.3.6.1.2.1.2.2.1.17.18
		# 0 1 2 3 4 5 6 7 8 9  10
		my (@opath) = split /\./, $oid;

		# TODO: Sanity Checks
		my $field = $opath[9];
		my $ifId = $opath[10];

		# should i use constants?
		my $fieldname = $ifEntry_fields{ $field };

		next unless $fieldname;

		$interfaces{$ifId}{$fieldname} = $value;
	}

	# list isn't sorted
	for my $if ( values %interfaces ) {
		# TODO:
		#  - sanitychecks 
		#  - printf *hmmm*
		print	( "ITEM ", $if->{ifDescr}, " 0 <none> 0 bytes packets bytes\n"
			, "ATTR bytes ", $if->{ifInOctets}, " ", $if->{ifOutOctets}, "\n"
			, "ATTR packets ", $if->{ifInUcastPkts}, " ", $if->{ifOutUcastPkts}, "\n"
			, "END_ITEM\n"
			);
	}

	print "END_GROUP\n";
	print "END_NODE\n";
	print "END_UPDATE\n";
	$| = 1;

	# TODO: how many interations? only one? ... forever -- tgr
	# exit;
	sleep 1;
}
# NODE test 2005-234-324 234:324:324.234"
# ITEM eth0 0 <none> 0"
# ATTR bytes 123123 123123"
# ATTR packets 123123 123123"
# END_ITEM"
# ITEM test 0 eth0 0"
# ATTR bytes 223123 223123"
# ATTR packets 223123 223123"
# END_ITEM"
# END_NODE"

