%{
 #include "db_filter.yacc.h"
 #include <bmon/bmon.h>
 #include <bmon/utils.h>

 static void __attribute__ ((unused)) yyunput (int c,char *buf_ptr  );
 static void __attribute__ ((unused)) yy_push_state (int  new_state );
 static void __attribute__ ((unused)) yy_pop_state  (void);
 static int  __attribute__ ((unused)) yy_top_state (void );

%}

%x str

%option 8bit stack warn bison-bridge noyywrap prefix="db_filter_"
%%

 static char strbuf[1024];

\(					{
						memset(strbuf, 0, sizeof(strbuf));
						BEGIN(str);
					}

<str>\)					{
						BEGIN(INITIAL);
						yylval->s = strdup(strbuf);
						return NAME;
					}

<str>\\					{
						strncat(strbuf, "\\", sizeof(strbuf) - strlen(strbuf) - 1);
					}

<str>\\\)				{
						strncat(strbuf, ")", sizeof(strbuf) - strlen(strbuf) - 1);
					}

<str>\\\(				{
						strncat(strbuf, "(", sizeof(strbuf) - strlen(strbuf) - 1);
					}

<str>[^\)]+				{
						strncat(strbuf, yytext, sizeof(strbuf) - strlen(strbuf) - 1);
					}

\.						return SEPARATOR;
\*						return WILDCARD;
\@						return ATTR_SEP;

[1-9][0-9]*|0[0-7]*|0x[0-9a-fA-F]+	{
						yylval->i = strtol(yytext, NULL, 0);
						return NUMBER;
					}

[^\.\@]+				{
						yylval->s = strdup(yytext);
						return NAME;
					}
%%
